using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;
using System.Collections;
using System.Runtime.InteropServices;

namespace SyncMDIApp
{
    public partial class MainForm : Form
    {
        TabbedMDIManager tabbedMDIManager1 = new TabbedMDIManager();
        static int UniqueNumber = 1;

        public MainForm()
        {
            InitializeComponent();
            tabbedMDIManager1.AttachToMdiContainer(this);
            tabbedMDIManager1.UseIconsInTabs = false;
            this.dockingManager1.DockControl(this.panel1, this, DockingStyle.Left, 150);
            this.dockingManager1.SetDockLabel(this.panel1, ".NET Controls");
            this.dockingManager1.SetCloseButtonVisibility(this.panel1, false);
            
            this.FormClosing += new FormClosingEventHandler(MainForm_FormClosing);
        }

        /// <summary>
        /// Do the clean-up of the each child when the parent form closes
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            IEnumerator ienum = this.dockingManager1.Controls;
            ArrayList dockedctrls = new ArrayList();
            while (ienum.MoveNext())
                dockedctrls.Add(ienum.Current);
            this.dockingManager1.LockHostFormUpdate();
            foreach (Control ctrl in dockedctrls)
            {
                this.dockingManager1.SetEnableDocking(ctrl, false);
                ctrl.Dispose();
            }
            this.dockingManager1.UnlockHostFormUpdate();

            this.dockingManager1.Dispose();
        }


        private void barItem2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void barItem1_Click(object sender, EventArgs e)
        {
            ChildForm form = new ChildForm();
            string name = UniqueName();
            form.TopLevel = false;
            form.FormBorderStyle = FormBorderStyle.None;
            form.Name = name;
            form.Text = name;
            //Size size = new Size(form.Width, form.Height);
         
            this.dockingManager1.LockHostFormUpdate();
            //this.dockingManager1.SetEnableDocking(form, true);
            this.dockingManager1.DockControl(form, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Right, 0);
            this.dockingManager1.SetAsMDIChild(form, true);
            //this.dockingManager1.SetControlSize(form, size);
            this.dockingManager1.UnlockHostFormUpdate();
       
            //form.Height = size.Height;
            //form.Width = size.Width;
        }

        string UniqueName()
        {
            string ret = "Child Form " + UniqueNumber.ToString();
            UniqueNumber++;
            return ret;
        }
    }
}